/*
***************************************************************************

   X server for LibGGI - Basic definitions

   Copyright (C) 1998-2000 Marcus Sundberg	[marcus@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

***************************************************************************
*/

#ifndef _XGGI_H
#define _XGGI_H


#include "xggi_struct.h"


/* accel */
Bool xggiAccelInit(int scr);
Bool xggiAccelInitBackingStore(int scr);


/* mode */
int xggiSwitchMode(int scr, ggi_mode *mode);


/* screen */
int xggiScreenAlloc(int numvisuals);
int xggiScreenFree(void);
Bool xggiScreenInit(ScreenPtr pScreen, pointer pbits,
			int xsize, int ysize, int dpix, int dpiy, int width);
int xggiGetScreenIdx(ScreenPtr screen);



/* visual */
int xggiVisualAlloc(struct xggiScreenInfo *screen, int numvisuals);
int xggiVisualFree(struct xggiScreenInfo *screen);
int xggiGetVisualIdx(int scr, VisualID visualid);


/* Input */
void xggiQueueKeyboardEvent(ggi_event *ev);
int xggiKeybdProc(DeviceIntPtr pDevice, int onoff);


/* display */
void xggiMapDisplay(void);
void xggiUnmapDisplay(void);


#endif /* _XGGI_H */
